# -*- coding: utf-8 -*-
{
    'name': "KKM Server Plus+",
    "license": "LGPL-3",
    'summary': """
        Интеграция с онлайн кассами через ККМСервер""",

    'description': """
        Интеграция с онлайн кассами через ККМСервер, проверка маркировки Честный Знак
    """,

    'author': "MK.Lab, devrave",
    'website': "https://inf-centre.ru",

    'category': 'Uncategorized',
    'version': '16.2024',

    'depends': ['point_of_sale', 'pos_lot_selection'],

    'installable': True,

    'data': [
        'security/ir.model.access.csv',
        'views/pos.xml',
        'static/src/xml/PosIndex.xml',
    ],

    'assets': {
       'point_of_sale.assets': [
           'kkm_server_plus/static/src/js/UniversalIDUpdate.js',
           #'kkm_server_plus/static/src/js/UniversalIDUpdate.xml',
           'kkm_server_plus/static/src/js/PosModel.js',
           'kkm_server_plus/static/src/js/open.js',
           'kkm_server_plus/static/src/js/close.js',
           'kkm_server_plus/static/src/js/ReportX.js',
           'kkm_server_plus/static/src/js/CleanGUID.js',
           'kkm_server_plus/static/src/xml/service_charge.xml',
           'kkm_server_plus/static/src/js/All_js.js',
           'kkm_server_plus/static/src/js/Cash.js',
           'kkm_server_plus/static/src/js/PayByPaymentCard.js',
           'kkm_server_plus/static/src/js/CancelPaymentByPaymentCard.js',
           'kkm_server_plus/static/src/js/ReturnPaymentByPaymentCard.js',
           'kkm_server_plus/static/src/js/Pay.js',
           'kkm_server_plus/static/src/js/ClosePop.js',
           'kkm_server_plus/static/src/js/TerminalReport.js',
           'kkm_server_plus/static/src/xml/ClosePop.xml',
           'kkm_server_plus/static/src/xml/PayByPaymentCard.xml',
           'kkm_server_plus/static/src/js/CheckKM.js',
       ],
    },

    'qweb': [
        'static/src/xml/*.xml',
    ],

}
