var glSelf;
odoo.define('kkm_server.ClosePosPopup', function(require) {
    "use strict";

    const { _t } = require('web.core');
    const ClosePosPopup = require('point_of_sale.ClosePosPopup');
    const Registries = require('point_of_sale.Registries');
    const NumberBuffer = require('point_of_sale.NumberBuffer');

    const PosKKMClosePosPopup = (ClosePosPopup) => class extends ClosePosPopup {

        /**
        * @override
        */
        async closeSession() {
            glSelf = this;
            console.log('ClosePosPopup');
            LogJS('info','ClosePosPopup')
            var enable_kkm_server = this.env.pos.config.enable_kkm_server
            var UseTerminal = this.env.pos.config.UseTerminal
            if (enable_kkm_server && UseTerminal){
                var self = this;
                var UrlServer = this.env.pos.config.UrlServer;
                if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
                var User = this.env.pos.config.User;
                var Password = this.env.pos.config.Password;
                var NumDevice = 0;
                if (this.env.pos.config.NumDevice_term!=undefined && this.env.pos.config.NumDevice_term!=false){
                    NumDevice=this.env.pos.config.NumDevice_term
                }
                var InnKkm = "";
                if (this.env.pos.config.InnKkm_term!=undefined && this.env.pos.config.InnKkm_term!=false){
                    InnKkm=this.env.pos.config.InnKkm_term
                }
                var Data = {
                    Command: "Settlement",
                    InnKkm: InnKkm,
                    NumDevice: NumDevice,
                    IdCommand: guid()
                    };
                console.log('Data',JSON.stringify(Data));
                LogJS('warning','Data: '+JSON.stringify(Data))
                ExecuteCommand(UrlServer,User,Password,Data);
            }
            await super.closeSession();
            }


    };

    Registries.Component.extend(ClosePosPopup, PosKKMClosePosPopup);

    return PosKKMClosePosPopup;
});
