var glSelf;
var self;

odoo.define('pos_button.pay_all_kkm', function(require) {
'use strict';
  const { Gui } = require('point_of_sale.Gui');
  const PosComponent = require('point_of_sale.PosComponent');
  const { identifyError } = require('point_of_sale.utils');
  const ProductScreen = require('point_of_sale.ProductScreen');
  const { useListener } = require("@web/core/utils/hooks");
  const Registries = require('point_of_sale.Registries');
  const PaymentScreen = require('point_of_sale.PaymentScreen');
  const Chrome = require('point_of_sale.Chrome');

   const KKM_Pay_All = (PaymentScreen) =>
       class extends PaymentScreen {

        KKM_pay_all_click() {
                self = this;
                glSelf = this;
                console.log('KKM_pay_all_click');
                LogJS('info','KKM_pay_all_click')
                var order = this.env.pos.get_order();
                var enable_kkm_server = this.env.pos.config.enable_kkm_server
                var UseTerminal = this.env.pos.config.UseTerminal
                var quantities = _.map(order.get_orderlines(), function (line) {return line.quantity; });
                var plus=0;
                var minus = 0;
                var type=0;
                var Amount = 0;
                var paymentlines = order.get_paymentlines();
                for (var i = 0; i < paymentlines.length; i++) {
                    if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
                };
                if (enable_kkm_server && UseTerminal){
                    for (var i = 0; i < quantities.length; i++) {
                        if (quantities[i]>0){plus=plus+1;}
                        if (quantities[i]<0){minus=minus+1;}
                        if (plus>0 && minus==0){type=0;}
                        if (plus==0 && minus>0){type=1;}
                        if (plus>0 && minus>0){type=99;}
                    }
                    if (type==99){
                        alert("Ошибка! Нельзя в одном чеке делать приход и возврат.");
                        return;
                        }
                    if (type==1 & Amount>0) {
                        console.log('Возврат платежа по карте');
                        LogJS('info','Возврат платежа по карте')
                        if (order.pay_return_kkm_guid!=undefined && order.pay_return_kkm_guid!=false){
                            console.log('Возврат платежа');
                            LogJS('info','Возврат платежа')
                            var Data = {
                                Command: "GetRezult",
                                IdCommand: order.pay_return_kkm_guid,
                            };
                            console.log('Data',JSON.stringify(Data));
                            LogJS('warning','Data: '+JSON.stringify(Data))
                            ExecuteCommandSetRezult(UrlServer,User,Password,Data,null,order.pay_return_kkm_guid, ExecuteSuccessSetRezultOnly, null, false)
                        }
                        else{
                            if (order.pay_cancel_kkm_guid!=undefined && order.pay_cancel_kkm_guid!=false){
                                console.log('Отмена платежа');
                                LogJS('info','Отмена платежа')
                                var Data = {
                                    Command: "GetRezult",
                                    IdCommand: order.pay_cancel_kkm_guid,
                                };
                                console.log('Data',JSON.stringify(Data));
                                LogJS('warning','Data: '+JSON.stringify(Data))
                                ExecuteCommandSetRezult(UrlServer,User,Password,Data,null,order.pay_cancel_kkm_guid, ExecuteSuccessSetRezultOnly, null, false)
                            }
                            else{
                                alert('Отсутствует guid операции возврата платежа на банковскую карту. Выполните возврат на банковскую карту.')
                            }
                        }
                    }
                    else{
                        if (type==0 & Amount>0){
                            console.log('Платеж по карте');
                            LogJS('info','Платеж по карте')
                            if (order.pay_kkm_guid!=undefined && order.pay_kkm_guid!=false){
                                var Data = {
                                    Command: "GetRezult",
                                    IdCommand: order.pay_kkm_guid,
                                };
                                console.log('Data',JSON.stringify(Data));
                                LogJS('warning','Data: '+JSON.stringify(Data))
                                ExecuteCommandSetRezult(UrlServer,User,Password,Data,null,order.pay_kkm_guid, ExecuteSuccessSetRezultOnly, null, false)
                            }
                            else{
                                this.KKM_Pay_By_Payment_Card_click()
                                //alert('tut')
                                //alert('Отсутствует guid операции платежа по банковской карте. Выполните платеж банковской картой.')
                            }
                        }
                        else{
                            console.log('Платеж/возврат наличными');
                            LogJS('info','Платеж/возврат наличными')
                            this.validateOrder(false)
                        }
                    }
                }
                else{
                    console.log('Операция без применения ккм');
                    LogJS('info','Операция без применения ккм')
                    this.validateOrder(false)
                }
              }
           };

//           KKM_pay_all_click() {
//                var self = this;
//                var order = this.env.pos.get_order();
//                var enable_kkm_server = this.env.pos.config.enable_kkm_server
//                var quantities = _.map(order.get_orderlines(), function (line) {return line.quantity; });
//                var plus=0;
//                var minus = 0;
//                var type=0;
//                var Amount = 0;
//                var paymentlines = order.get_paymentlines();
//                for (var i = 0; i < paymentlines.length; i++) {
//                    if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
//                };
//                if (enable_kkm_server){
//                    for (var i = 0; i < quantities.length; i++) {
//                        if (quantities[i]>0){plus=plus+1;}
//                        if (quantities[i]<0){minus=minus+1;}
//                        if (plus>0 && minus==0){type=0;}
//                        if (plus==0 && minus>0){type=1;}
//                        if (plus>0 && minus>0){type=99;}
//                    }
//                    if (type==99){
//                        alert("Ошибка! Нельзя в одном чеке делать приход и возврат.");
//                        return;
//                        }
//                    if (type==1 & Amount>0) {
//                        this.KKM_Return_Payment_By_Payment_Card_click()
//                    }
//                    else{
//                        if (type==0 & Amount>0){
//                            this.KKM_Pay_By_Payment_Card_click()
//                        }
//                        else{
//                            this.validateOrder(false)
//                        }
//                    }
//                }
//                else{
//                    this.validateOrder(false)
//                }
//              }
//           };

   Registries.Component.extend(PaymentScreen, KKM_Pay_All);
   return KKM_Pay_All;
});

function ExecuteSuccessSetRezultOnly(Rezult, textStatus, jqX) {
            console.log('ExecuteSuccessSetRezultOnly');
            LogJS('info','ExecuteSuccessSetRezultOnly')
            var state = Rezult.Status;
            console.log('Rezult: ',JSON.stringify(Rezult));
            LogJS('warning','Rezult: '+JSON.stringify(Rezult))
            console.log('Status: ',Rezult.Status);
            LogJS('warning','Status: '+Rezult.Status)
            if (state == 1 || state == 4) {
                alert('Терминал еще ожидает платеж. Проверьте статус платежа позже');
            } else {
                if (state==0){
                    if (Rezult.Rezult.UniversalID){
                        ord.set_kkm_UniversalID(Rezult.Rezult.UniversalID)
                    }
                    if (Rezult.Rezult.Slip!=undefined){
                        console.log('Slip: ',Rezult.Rezult.Slip);
                        LogJS('warning','Slip: '+Rezult.Rezult.Slip)
                        var res_short = Rezult.Rezult.Slip.toLowerCase();
                        if (res_short.indexOf('код ответа')>-1){
                            res_short = res_short.slice(res_short.indexOf('код ответа'))
                            res_short = res_short.slice(0,res_short.indexOf('\n'))
                            res_short = res_short.replace('код ответа','').replace(':','').trim()
                            if (res_short=='000' || res_short=='r00'){
                                self.validateOrder(false)
                            }
                            else{
                                if (res_short.indexOf('одобрено')>-1){
                                    self.validateOrder(false)
                                }
                                else{
                                    alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                    return;
                                }
                            }
                        }
                        else{
                                if (res_short.indexOf('одобрено')>-1){
                                    self.validateOrder(false)
                                }
                                else{
                                    alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                    return;
                                }
                            }
                    }
                    else{
                        alert('Не вернулся слип чек')
                     }
                }
                else{
                    alert('Работа терминала завершилась с ошибкой');
                }
            }
        }