var mes="";
var glSelf;

odoo.define('kkm_server.reportx_kkm', function(require) {
'use strict';
  const { Gui } = require('point_of_sale.Gui');
  const PosComponent = require('point_of_sale.PosComponent');
  const { identifyError } = require('point_of_sale.utils');
  const ProductScreen = require('point_of_sale.ProductScreen');
  const { useListener } = require("@web/core/utils/hooks");
  const Registries = require('point_of_sale.Registries');
  const PaymentScreen = require('point_of_sale.PaymentScreen');

class KKM_ReportX extends PosComponent {
      setup() {
          super.setup();
          useListener('click', this.onClick);
      }
     async onClick() {
        var self = this;
        glSelf = this;
        console.log('reportx_kkm');
        LogJS('info','reportx_kkm')
        var UrlServer = this.env.pos.config.UrlServer;
        if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
        var User = this.env.pos.config.User;
        var Password = this.env.pos.config.Password;
        var NumDevice = 0;
        if (this.env.pos.config.NumDevice_fiscal!=undefined && this.env.pos.config.NumDevice_fiscal!=false){
                NumDevice=this.env.pos.config.NumDevice_fiscal
            }
        var InnKkm = ''
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                InnKkm=this.env.pos.config.InnKkm_fiscal
            }
        XReport(NumDevice,UrlServer,User,Password,InnKkm);
     }
  }

  KKM_ReportX.template = 'KKM_ReportX';
  ProductScreen.addControlButton({
      component: KKM_ReportX,
      condition: function () {
            var has_enabled = false;
            if (this.env.pos.config.enable_kkm_server) {
                has_enabled = true;
            }
            return has_enabled;
        },
      position: ['before', 'RefundButton'],
  });

  Registries.Component.add(KKM_ReportX);

  return KKM_ReportX;
});




