var glSelf;
var CashierName;
var CashierVATIN;
odoo.define('kkm_server.CashButton', function(require) {
    "use strict";

    const { _t } = require('web.core');
    const PaymentScreen = require('point_of_sale.PaymentScreen');
    const Registries = require('point_of_sale.Registries');
    const NumberBuffer = require('point_of_sale.NumberBuffer');
    const CashMovePopup = require('point_of_sale.CashMovePopup');
    const AbstractAwaitablePopup = require('point_of_sale.AbstractAwaitablePopup');
    const { _lt } = require('@web/core/l10n/translation');
    const { parse } = require('web.field_utils');
    const { useRef, useState } = owl;

    const PosKKMCashButton = (CashMovePopup) => class extends CashMovePopup {
        confirm() {
            glSelf = this;
            console.log('CashButton');
            LogJS('info','CashButton')
            var UrlServer = this.env.pos.config.UrlServer;
            if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
            var User = this.env.pos.config.User;
            var Password = this.env.pos.config.Password;
            var res = super.confirm();
            var Amount = this.state.inputAmount;
            var NumDevice = 0
            if (this.env.pos.config.NumDevice_fiscal!=undefined && this.env.pos.config.NumDevice_fiscal!=false){
                NumDevice=this.env.pos.config.NumDevice_fiscal
            }
            var InnKkm = ''
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                InnKkm=this.env.pos.config.InnKkm_fiscal
            }
            var Command = ""
            if (res===undefined){
                return res;
            }
            if (this.state.inputType === 'out') {
                Command = "PaymentCash";
            }
            if (this.state.inputType === 'in') {
                Command = "DepositingCash";
            }
            var res = this.env.services.rpc({
                route: '/cashier/info',
                params: {
                    cashier_id: this.env.pos.get_cashier_user_id(),
                },
            }, { shadow: true }).then((value) => { CashierName = value['name'];
                                                CashierVATIN =  value['inn'];
                                                if (Command!=""){
                                                    var Data = {
                                                        Command: Command,
                                                        InnKkm: InnKkm,
                                                        NumDevice: NumDevice,
                                                        CashierName: CashierName,
                                                        CashierVATIN: CashierVATIN,
                                                        Amount: Amount,
                                                        IdCommand: guid()
                                                    };
                                                    console.log('Data',JSON.stringify(Data));
                                                    LogJS('warning','Data: '+JSON.stringify(Data))
                                                    ExecuteCommand(UrlServer,User,Password,Data);
                                                }
                                                return res;
                                                }).catch((err) => {
                                                CashierName = this.env.pos.config.CashierName[1];
                                                CashierVATIN = this.env.pos.config.CashierVATIN;
                                                if (Command!=""){
                                                    var Data = {
                                                        Command: Command,
                                                        InnKkm: InnKkm,
                                                        NumDevice: NumDevice,
                                                        CashierName: CashierName,
                                                        CashierVATIN: CashierVATIN,
                                                        Amount: Amount,
                                                        IdCommand: guid()
                                                    };
                                                    console.log('Data',JSON.stringify(Data));
                                                    LogJS('warning','Data: '+JSON.stringify(Data))
                                                    ExecuteCommand(UrlServer,User,Password,Data);
                                                }
                                                return res;
                                                });

        }
    };

    CashMovePopup.template = 'point_of_sale.CashMovePopup';
    CashMovePopup.defaultProps = {
        cancelText: _lt('Cancel'),
        title: _lt('Cash In/Out'),
    };
    Registries.Component.extend(CashMovePopup, PosKKMCashButton);

    return CashMovePopup;
});