var NumDevice;
var InnKkm;
var TaxVariant;
var KktNumber;
var IdCommand;
var UrlServer;
var Password;
var User;
var self;
var order;
var glSelf;

odoo.define('kkm_server.check_km_kkm', function(require) {
'use strict';

    const PosComponent = require('point_of_sale.PosComponent');
    const { identifyError } = require('point_of_sale.utils');
    const ProductScreen = require('point_of_sale.ProductScreen');
    const { useListener } = require("@web/core/utils/hooks");
    const Registries = require('point_of_sale.Registries');
    const PaymentScreen = require('point_of_sale.PaymentScreen');
    const Chrome = require('point_of_sale.Chrome');
    const BarcodeReader = require('point_of_sale.BarcodeReader');
    const { get_lot_lines } = require('point_of_sale.models');
    const {PosGlobalState} = require("point_of_sale.models");
    var core = require('web.core');
    var utils = require('web.utils');
    const PosLotSaleProductScreen = require('pos_lot_selection.ProductScreen');

// Проверка кодов маркировки
function ValidationMarkingCode(NumDevice,UrlServer,User,Password,InnKkm,product) {
    var Data = {
        Command: "ValidationMarkingCode",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        TaxVariant: "",
        KktNumber: "",
        "GoodCodeDatas": [{
            "Name": product.display_name, 
            "Barcode": window.selectedLot,
            Quantity: 1,
            MeasureOfQuantity: 0,
            PackageQuantity: null,
        },
    ],
        IdCommand: guid(),
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);

}

// Barcode scaner
    BarcodeReader.include({
        scan: async function (code) {
            if (!code) return;
            self = this;
            glSelf = this;
            UrlServer = this.env.pos.config.UrlServer;
            if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
            User = this.env.pos.config.User;
            Password = this.env.pos.config.Password;
            var NumDevice = this.env.pos.config.NumDevice_term;
            var InnKkm = "";
            if (this.env.pos.config.InnKkm_term!=undefined && this.env.pos.config.InnKkm_term!=false){
                InnKkm=this.env.pos.config.InnKkm_term
            }
            const callbacks = Object.keys(this.exclusive_callbacks).length
                ? this.exclusive_callbacks
                : this.action_callbacks;
            let parsed_result = this.barcode_parser.parse_barcode(code);
            const product = this.env.pos.db.get_product_by_barcode(code);
            if (Array.isArray(parsed_result)) {
                [...callbacks.gs1].map(cb => cb(parsed_result));
            } else {
                if (callbacks[parsed_result.type]) {
                    for (const cb of callbacks[parsed_result.type]) {
                        await cb(parsed_result);
                        if (window.lot_error == true) {
                            return;
                        }
                        ValidationMarkingCode(NumDevice,UrlServer,User,Password,InnKkm,product);
                        return;
                    }
                } else if (callbacks.error) {
                        [...callbacks.error].map(cb => cb(parsed_result));
                    } else {
                        console.warn(`Ignored Barcode scan:`, parsed_result);   
                    }
            }
        },
    });

    return BarcodeReader;

}); 